//+------------------------------------------------------------------+
//|                                NSE Stock Chart V10 RealTime.mq4  |
//|                                          Develop by     Ramdas   |
//|                         This is Indicator and used offline       |
//+------------------------------------------------------------------+
// This Indicator Read data of various timeframe from Google finace and creates chart
// one can use this utility for study of past price action.
// Note: 

#property copyright ""
#property link      ""

#property indicator_chart_window
#include <WinUser32.mqh>
#include <stdlib.mqh>
#include <ReadWebCSV.mqh>

#import "user32.dll"
	int RegisterWindowMessageA(string lpString); 
#import

#define  NL    "\n" 
#define  CHART_CMD_UPDATE_DATA            33324

extern bool EmulateOnLineChart = true;

   extern string StockName = "STER";  
   extern bool   Disable  = False;
   extern bool   M1  = False;      
   extern bool   M5  = True;   
   extern bool   M15 = True;       
   extern bool   M30 = True;     
   extern bool   H1  = True;     
   extern bool   D1  = True;   
   extern string BFPeriod_Y = "2Y";  
   extern string BFPeriod_D = "3d";
     
   bool   makeCSV  = True; 
   string url0  = "http://www.google.com/finance/getprices?q=";  
   string url_x = "&x=NSE";
   string url_i = "&i=";
   string url_p = "&p=";
   string url_f = "&f=d,c,h,l,o,v";
   string url_ts= "&ts=";                                        // BackFill start period e,g  &ts=1293444000
   
   string   url_i_M1  = "60";       
   string   url_i_M5  = "300";       
   string   url_i_M15 = "900";      
   string   url_i_M30 = "1800";   
   string   url_i_H1  = "3600";     
   string   url_i_D1  = "86400";

   string   hst_M1  = "1";       
   string   hst_M5  = "5";       
   string   hst_M15 = "15";      
   string   hst_M30 = "30";   
   string   hst_H1  = "60";     
   string   hst_D1  = "1440";
   
   string   stk.name[250],stk.url[250];
   string   strdata;
   string   DataStr;
   double   gmtoffset = 19800;
      int   HstHandle = -1;
      int   CSVHandle = -1;
      int   MT4InternalMsg = 0;

//http://www.google.com/finance/getprices?q=ACC&x=NSE&i=60&p=5d&f=d,c,o,h,l&df=cpct&auto=1&ts=1293444000
//http://www.google.com/finance/getprices?q=ACC&x=NSE&i=300&p=15d&ts=1293444000


//+------------------------------------------------------------------+
int init()
  {
     
  
 
         if (Period() == PERIOD_W1 ) WriteHSTheader0(Symbol(),hst_M1);   
         if (Period() == PERIOD_W1 ) WriteHSTheader0(Symbol(),hst_M5); 
         if (Period() == PERIOD_W1 ) WriteHSTheader0(Symbol(),hst_M15); 
         if (Period() == PERIOD_W1 ) WriteHSTheader0(Symbol(),hst_M30); 
         if (Period() == PERIOD_W1 ) WriteHSTheader0(Symbol(),hst_H1); 
         if (Period() == PERIOD_W1 ) WriteHSTheader0(Symbol(),hst_D1);    
                      
                  
         
    
   return(0);
  }

//----------------------------------------------------------
int start()
 {

         if (Period() == PERIOD_M1)
            {  
                DataStr = ReadWebPage(StockName, CreateUrl(url_i_M1,BFPeriod_D),makeCSV);
                CreateHST(StockName,hst_M1);
            } 
                    
         if (Period() == PERIOD_M5)
            {  
                DataStr = ReadWebPage(StockName, CreateUrl(url_i_M5,BFPeriod_D),makeCSV);
                CreateHST(StockName,hst_M5);
           } 
        
         if (Period() == PERIOD_M15)
            {  
                DataStr = ReadWebPage(StockName, CreateUrl(url_i_M15,BFPeriod_D),makeCSV);
                CreateHST(StockName,hst_M15);
            }      
        
         if (Period() == PERIOD_M30)
            {  
                DataStr = ReadWebPage(StockName, CreateUrl(url_i_M30,BFPeriod_D),makeCSV);
                CreateHST(StockName,hst_M30);
            }    
        
         if (Period() == PERIOD_H1)
            {  
                DataStr = ReadWebPage(StockName, CreateUrl(url_i_H1,BFPeriod_D),makeCSV);
                CreateHST(StockName,hst_H1);
             }
        
          if (Period() == PERIOD_D1)
            {  
                DataStr = ReadWebPage(StockName, CreateUrl(url_i_D1,BFPeriod_Y),makeCSV);
                CreateHST(StockName,hst_D1);
            }                  

 
     //RefreshChartWindow(Symbol(),Period()); 
        UpdateChartWindow();//
 return(0);
}
//-----------------------------------------------------
void UpdateChartWindow() {
	static int hwnd = 0;
 
	if(hwnd == 0) {
		hwnd = WindowHandle(StockName, Period());
		if(hwnd != 0) Print("Chart window detected");
	}

	if(EmulateOnLineChart && MT4InternalMsg == 0) 
		MT4InternalMsg = RegisterWindowMessageA("MetaTrader4_Internal_Message");

	if(hwnd != 0) if(PostMessageA(hwnd, WM_COMMAND, 0x822c, 0) == 0) hwnd = 0;
	if(hwnd != 0 && MT4InternalMsg != 0) PostMessageA(hwnd, MT4InternalMsg, 2, 1);

	return;
}

//+------------------------------------------------------------------+
// Create url  http://www.google.com/finance/getprices?q=ACC&x=NSE&i=3600&p=15d&f=d,c,h,l,o,v
//+------------------------------------------------------------------+
string CreateUrl( string TimeInterval, string FillPeriod)
   { return(url0 + StockName + url_x + url_i + TimeInterval + url_p + FillPeriod + url_f); } 

//+------------------------------------------------------------------+
// Create HST Files
//+------------------------------------------------------------------+
void CreateHST(string SymbolName,string hst_TF)
  {
  
      string market_open_min,market_close_min,interval,timezone_offset;     
      datetime dt_TS,dt_TSSync;  
      string s_TSRef;                                   
      double d_open,d_low,d_high,d_close,d_volume,d_TSCurr;
      bool skipp = false;
      
      int  i_unused[15];
      
                               
             HstHandle = FileOpenHistory(SymbolName + hst_TF + ".hst", FILE_BIN|FILE_WRITE);
              if(HstHandle < 0) return;
                
        
               FileWriteInteger(HstHandle, 400, LONG_VALUE);                       // Version
               FileWriteString( HstHandle, "", 64);                                // Copyright
               FileWriteString( HstHandle, SymbolName, 12);                        // Symbol
               FileWriteInteger(HstHandle, StrToInteger(hst_TF), LONG_VALUE);      // Digits
               FileWriteInteger(HstHandle, 2, LONG_VALUE);                         // Time Sign
               FileWriteArray(  HstHandle, i_unused, 0, 15); 
               FileFlush(HstHandle);
          
             
                CSVHandle = FileOpen(SymbolName + ".csv", FILE_CSV|FILE_READ,';' );
             if(CSVHandle < 0) 	{Alert( SymbolName + "CSV File not present   "+ CSVHandle); return(0);}  
                                                 
                     strdata = FileReadString(CSVHandle);   // EXCHANGE%3DNSE          
             market_open_min = FileReadString(CSVHandle);   // MARKET_OPEN_MINUTE=540    
            market_close_min = FileReadString(CSVHandle);   // MARKET_CLOSE_MINUTE=930
                    interval = FileReadString(CSVHandle);   // INTERVAL=300
                     strdata = FileReadString(CSVHandle);   // COLUMNS=DATE,CLOSE,HIGH,LOW,OPEN,VOLUME
                     strdata = FileReadString(CSVHandle);   // DATA=
             timezone_offset = FileReadString(CSVHandle);   // TIMEZONE_OFFSET=330
        
             market_open_min = StringSubstr(market_open_min,19,0);
            market_close_min = StringSubstr(market_close_min,20,0);
                    interval = StringSubstr(interval,9,0); 
             timezone_offset = StringSubstr(timezone_offset,16,0);
        
        while ( !FileIsEnding(CSVHandle) )
          {
                    
               strdata = FileReadString(CSVHandle);
              
           if (DataValidate(strdata,5) == True)   
             { 
                                                            
               s_TSRef = ExtractStr(strdata); // Time stamp
         
               if ( StringSubstr(s_TSRef,0,1) == "a") 
                  {
                  s_TSRef = StringSubstr(s_TSRef,1,0);
                    dt_TS = StrToInteger(s_TSRef)+ gmtoffset ;  
                dt_TSSync = dt_TS;
                  }
               else 
                  {
                     d_TSCurr = StrToInteger(s_TSRef);
                        dt_TS = dt_TSSync + (StrToInteger(interval) * d_TSCurr);
                  }
             
               d_close = StrToDouble(ExtractStr (strdata)); 
                d_high = StrToDouble(StringTrimLeft(ExtractStr(strdata))); 
                 d_low = StrToDouble(StringTrimLeft(ExtractStr(strdata))); 
                d_open = StrToDouble(StringTrimLeft(ExtractStr(strdata))); 
              d_volume = StrToDouble(StringTrimLeft(strdata)); 
                         
             if ( d_open == 0 || d_high == 0 ||d_low == 0 ||d_close == 0 ) {skipp = true;}
             else {skipp = false;}
         
             if ( d_open == d_high && d_low == d_close  ) {skipp = true;}
             else {skipp = false;}
        
             if (!skipp)
               {
                FileWriteInteger(HstHandle, dt_TS, LONG_VALUE);
                FileWriteDouble(HstHandle, d_open, DOUBLE_VALUE);
                FileWriteDouble(HstHandle, d_low, DOUBLE_VALUE);
                FileWriteDouble(HstHandle, d_high, DOUBLE_VALUE);
                FileWriteDouble(HstHandle, d_close, DOUBLE_VALUE);
                FileWriteDouble(HstHandle, d_volume, DOUBLE_VALUE);
               }
            } //DataValidate end    
          }  //while end
         
         FileFlush(HstHandle);
         FileSeek(HstHandle, 0, SEEK_SET);
         FileClose(HstHandle);
         FileClose(CSVHandle);
  }
//+------------------------------------------------------------------+
// Extract string
//+------------------------------------------------------------------+

string ExtractStr( string str1)
{

      string dataextract;
      int CommaIndex;
         
          CommaIndex = StringFind(str1,",",0);
          strdata  = StringSubstr(str1,CommaIndex+1, 0);
          dataextract = StringSubstr(str1,0,CommaIndex);
      
        return(dataextract); 
}

//+------------------------------------------------------------------+

bool DataValidate(string str3, int CommaCnt )
{
      int count = 0;
            
          int strlen = StringLen(str3);
          int cnt2=1;
           
          if (strlen < 10)  return(False);           
          
          for (cnt2 = 1; cnt2 <= strlen; cnt2++)             
            if (StringSubstr(str3,cnt2-1,1) == ",") count = count+1;
   
         if ( count == CommaCnt )return(True);
         
     return(False); 
}
//+------------------------------------------------------------------+
 bool CheckHST(string hst_TF)
 {
            HstHandle = FileOpenHistory(Symbol() + hst_TF + ".hst", FILE_BIN|FILE_READ);
             if(HstHandle < 0 || FileSize(HstHandle) <= 2 ) return(false);
              
             FileClose(HstHandle);  
             return(true);
}


//+------------------------------------------------------------------+
void WriteHSTheader0(string SymbolName,string hst_TF)
{

        int  i_unused[15];
        HstHandle = FileOpenHistory(SymbolName + hst_TF + ".hst", FILE_BIN|FILE_WRITE);
              if(HstHandle < 0) return;
                      
                FileFlush(HstHandle);
                FileClose(HstHandle);
}
//---------------------------------------------------------------------------------------------------------------------------------
void RefreshChartWindow(string SymbolName,string hst_TF)
{
             int hwnd = WindowHandle(SymbolName, hst_TF);                
             int result = PostMessageA(hwnd, WM_COMMAND, CHART_CMD_UPDATE_DATA, 1);
             if (result == 0) 
               Alert("PostMessage failed");
            
            return(0);
}    